#ifndef HARKIO_NOTINITIALIZED_HPP_
#define HARKIO_NOTINITIALIZED_HPP_

#include <stdexcept>
#include <string>

/** @file NotInitialized.hpp
 * @brief NotInitialized exception class definition.
 */

namespace harkio2
{

/** @brief Not initialized exception.
 * A exception class which represents that an item hasn't initialized yet.
 */
class NotInitialized : public std::runtime_error
{
public:
    explicit NotInitialized(const std::string& arg)
        : std::runtime_error(arg)
    {}
};

}

#endif // HARKIO_NOTINITIALIZED_HPP_

