#define BOOST_TEST_MODULE testcase for RegexPatterns
#define BOOST_TEST_DYN_LINK
#include "common.hpp"

#include <boost/test/unit_test.hpp>

#include <harkio2/RegexPatterns.hpp>
#include <string>
#include <boost/regex.hpp>
using namespace std;
using namespace boost;
using namespace harkio2::RegexPatterns;

BOOST_AUTO_TEST_CASE(decimal_test)
{
    regex r(DECIMAL);
    smatch m;
    string s;

    BOOST_CHECK(regex_match(string("103"), m, r));
    BOOST_CHECK(regex_match(string("1.2"), m, r));
    BOOST_CHECK(regex_match(string("0"), m, r));
    BOOST_CHECK(regex_match(string("0.204"), m, r));
    BOOST_CHECK(regex_match(string("-100.305"), m, r));
    BOOST_CHECK(regex_match(string("+2010.510"), m, r));
    BOOST_CHECK(regex_match(string("2.5e101"), m, r));
    BOOST_CHECK(regex_match(string("2.5e-202"), m, r));
    BOOST_CHECK(regex_match(string("2.5E+0"), m, r));

    BOOST_CHECK(!regex_match(string("01.23"), m, r));
    BOOST_CHECK(!regex_match(string("=1.2"), m, r));
}

BOOST_AUTO_TEST_CASE(integer_test)
{
    regex r(INTEGER);
    smatch m;
    string s;

    BOOST_CHECK(regex_match(string("103"), m, r));
    BOOST_CHECK(regex_match(string("204"), m, r));
    BOOST_CHECK(regex_match(string("-1024"), m, r));
    BOOST_CHECK(regex_match(string("+56708"), m, r));
    BOOST_CHECK(regex_match(string("0"), m, r));

    BOOST_CHECK(!regex_match(string("01"), m, r));
    BOOST_CHECK(!regex_match(string("=2"), m, r));
}

